<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table class="table table-bordered table-striped table-hover" id="user-table">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();

      $(".user-detail").on("click", function(){
        onBtnButtonClick(this);
      })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    function onPageLoading() {
      var vUserOjb = JSON.parse(gJsonUser);
      loadDataUserToTable(vUserOjb.users);
    }

    // hàm nút chi tiết được ấn
    function onBtnButtonClick(pagramButton){
      console.log("Nút chi tiết được ấn")

      var vUserId = $(pagramButton).data("userid");
      var vFirstName = $(pagramButton).data("firstname");
      var vLastName = $(pagramButton).data("lastname");
      var vAge = $(pagramButton).data("age");

      console.log("UserID: "+ vUserId );
      console.log("Firstname: "+ vFirstName );
      console.log("Lastname: "+ vLastName );
      console.log("Age: "+ vAge );

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function loadDataUserToTable(pagramUser) {
      var vUserTable = $("#user-table")
      for (var bI = 0; bI < pagramUser.length; bI++) {
        // thêm dòng mới 
        var bNeưRoww = $("<tr>").appendTo(vUserTable);
        // thêm cột

        // Cách 1: 
        // var bNewCode = $("<td>")
        //   .appendTo(bNeưRoww)
        //   .html(pagramUser[bI].userId);

        // cách 2 : thường dùng cách này.
        $("<td>", { html: pagramUser[bI].userId }).appendTo(bNeưRoww);
        $("<td>", { html: pagramUser[bI].firstname }).appendTo(bNeưRoww);
        $("<td>", { html: pagramUser[bI].lastname }).appendTo(bNeưRoww);
        $("<td>", { html: pagramUser[bI].age }).appendTo(bNeưRoww);

        var bActionCell = $("<td>").appendTo(bNeưRoww);
        var bDetailButton = $("<button>").appendTo(bActionCell)
          .html("Chi tiết")
          .addClass("btn btn-primary user-detail")
          .data("userid",pagramUser[bI].userId )
          .data("firstname",pagramUser[bI].firstname )
          .data("lastname",pagramUser[bI].lastname )
          .data("age",pagramUser[bI].age )
      }
    }
  </script>
</body>

</html>
​